/* 
 * EDOMI beta (Version 1.64) - Intelligente Steuerung und Visualisierung KNX-basierter Elektro-Installationen.
 * @link http://www.edomi.de 
 * @author Dr. Christian Gärtner <dr.christian.gaertner@googlemail.com> 
 * @copyright 2015,2016,2017 Dr. Christian Gärtner 
 * @license Freeware 
 *
 *     This file and all other files are part of EDOMI.
 *
 *     EDOMI is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 *     Diese und alle anderen Dateien sind Teil von EDOMI.
 *
 *     EDOMI wird in der Hoffnung, dass es nützlich sein wird, aber
 *     OHNE JEDE GEWÄHRLEISTUNG, bereitgestellt; sogar ohne die implizite
 *     Gewährleistung der MARKTFÄHIGKEIT oder EIGNUNG FÜR EINEN BESTIMMTEN ZWECK.
*/ 
//Controltyp 13 (Schieberegler)
//----------------------------

function control13_constructControl(obj,item) {
	var n="<div id='e-"+item.id+"-container' style='position:absolute; left:0; top:0; width:100%; height:100%; pointer-events:none;'>";
		n+="<table cellpadding='0' cellspacing='0' border='0' style='width:100%; height:100%;'>";
			n+="<tr><td><span id='e-"+item.id+"-text'></span></td></tr>";
		n+="</table>";
		if (obj.dataset.var2&1) {
			n+="<div id='e-"+item.id+"-deco1' style='position:absolute; box-sizing:border-box; background:transparent; pointer-events:none;'></div>";
			n+="<div id='e-"+item.id+"-deco2' style='position:absolute; box-sizing:border-box; background:transparent; pointer-events:none;'></div>";
		}
		if (obj.dataset.var2&4) {n+="<div id='e-"+item.id+"-editvalue' style='display:none; position:absolute; left:0; top:0; right:0; bottom:0; color:"+visu_indiColorText+";'></div>";}
		n+="<div id='e-"+item.id+"-cursor1' style='display:none; position:absolute; box-sizing:border-box; border-color:"+visu_indiColor+";'></div>";
	n+="</div>";
	obj.innerHTML=n;

	if (isNaN(parseFloat(obj.dataset.var5)) || isNaN(parseFloat(obj.dataset.var6))) {
		obj.dataset.var5=0;
		obj.dataset.var6=100;
	}

	obj.addEventListener(downEvent,function(){if (!checkClick()){return;} control13_Start(item.id);},false);
}

function control13_refreshControl(obj,init) {
	var kovalue=getKoValue(obj);
	document.getElementById("e-"+obj.dataset.id+"-text").innerHTML=pS(obj.dataset.d_text,kovalue);
	control13_Init(obj.dataset.id);
}

function control13_Init(elementId) {
	var d=document.getElementById("e-"+elementId);
	if (d.dataset.var2&1) {

		var kovalue=getKoValue(d);

		element_centerLine(document.getElementById("e-"+elementId+"-container"),document.getElementById("e-"+elementId+"-deco1"));

		//Knopf
		element_centerLine(document.getElementById("e-"+elementId+"-container"),document.getElementById("e-"+elementId+"-deco2"),50,0,true);
		var size=control13_getSize(elementId);
		var tmp=element_getDefaultPosition(kovalue,d.dataset.var5,d.dataset.var6,0,size.l);
		if (tmp!==false) {
			if (d.dataset.var3&1) {tmp=size.l-tmp;}
			if (size.o==0) {
				document.getElementById("e-"+elementId+"-deco2").style.left=(tmp-1)+"px";
			} else {
				document.getElementById("e-"+elementId+"-deco2").style.top=(tmp-1)+"px";
			}
		}
	}
}

function control13_Start(elementId) {
	if (!event) var event=window.event;
	var d=document.getElementById("e-"+elementId);

	var kovalue=getKoValue(d);
	element_drag.id=elementId;
	resetKoValue_Interval(((d.dataset.var1&1)?"":kovalue));

	if (d.dataset.var2&1 && d.dataset.var2&2) {
		document.getElementById("e-"+elementId+"-deco2").style.display="none";
	}
	if (d.dataset.var2&2) {
		document.getElementById("e-"+elementId+"-cursor1").style.display="block";
		element_centerLine(document.getElementById("e-"+elementId+"-container"),document.getElementById("e-"+elementId+"-cursor1"),50,0,true);
		document.getElementById("e-"+elementId+"-cursor1").style.borderColor=visu_indiColor;
	}
	if (d.dataset.var2&4) {
		document.getElementById("e-"+elementId+"-text").style.display="none";
		document.getElementById("e-"+elementId+"-editvalue").style.display="block";
	}
	
	//KO parsen und Startposition merken
	var canvas=document.getElementById("e-"+elementId+"-container");

	var size=control13_getSize(elementId);
	getMouseValue(d,canvas,true,kovalue,(size.o+1),0,null,d.dataset.var5,d.dataset.var6,d.dataset.var5,d.dataset.var6,null,null,d.dataset.var8,d.dataset.var7,null,size.flip);						

	control13_Move();

	window.addEventListener(moveEvent,control13_Move,false);
	window.addEventListener(upEvent,control13_Send,false);

	if (visu_allowScrolling) {
		//Scrolling temporär verhindern
		window.addEventListener(moveEvent,disableScrolling,false);
	}
}

function control13_Move() {
	if (!event) var event=window.event;
	if (element_drag.id>0) {
		var d=document.getElementById("e-"+element_drag.id);
		if (d) {
			var canvas=document.getElementById("e-"+element_drag.id+"-container");
			var size=control13_getSize(element_drag.id);
			var pos=getMouseValue(d,canvas,false,null,(size.o+1),0,((d.dataset.var1&1)?0:1),d.dataset.var5,d.dataset.var6,d.dataset.var5,d.dataset.var6,null,null,d.dataset.var8,d.dataset.var7,null,size.flip);						
			if (size.o==0) {var value=pos.valuex;} else {var value=pos.valuey;}

			if (d.dataset.var2&2) {
				if (size.o==0) {
					var tmp=pos.cursorx;
					if (d.dataset.var3&1) {tmp=size.l-tmp;}
					document.getElementById("e-"+element_drag.id+"-cursor1").style.left=(tmp-1)+"px";
				} else {
					var tmp=pos.cursory;
					if (d.dataset.var3&1) {tmp=size.l-tmp;}
					document.getElementById("e-"+element_drag.id+"-cursor1").style.top=(tmp-1)+"px";
				}
			}
			if (d.dataset.var2&4) {document.getElementById("e-"+element_drag.id+"-editvalue").innerHTML="<button class='elementContent'><span style='background:"+visu_indiColor+"; color:"+visu_indiColorText+"; padding:1px; border-radius:3px;'>"+pS(d.dataset.d_caption,value)+"</span></button>";}

			//KO setzen und Wert merken
			element_drag.koeditvalue=value;
			setKoValue_Interval(element_drag.id,true,d.dataset.var4);			
		}
	}
}

function control13_Send() {
	var d=document.getElementById("e-"+element_drag.id);
	if (d) {
		setKoValue_Interval(element_drag.id,false);

		document.getElementById("e-"+element_drag.id+"-text").style.display="inline";
		if (d.dataset.var2&1) {
			document.getElementById("e-"+element_drag.id+"-deco1").style.display="block";
			document.getElementById("e-"+element_drag.id+"-deco2").style.display="block";
		}
		if (d.dataset.var2&4) {document.getElementById("e-"+element_drag.id+"-editvalue").style.display="none";}
		document.getElementById("e-"+element_drag.id+"-cursor1").style.display="none";
		
		element_drag.id=0;
		window.removeEventListener(moveEvent,control13_Move,false);
		window.removeEventListener(upEvent,control13_Send,false);

		if (visu_allowScrolling) {
			//Scrolling wieder freigeben
			window.removeEventListener(moveEvent,disableScrolling,false);
		}
	}
}

function control13_getSize(elementId) {
	var d=document.getElementById("e-"+elementId);
	if (d) {
		var flip=false;
		var tmp=element_getSize(document.getElementById("e-"+elementId+"-container"));
		if (d.dataset.var3&1) {flip=true;}
		if (tmp.w>=tmp.h) {
			return {o:0,l:tmp.w,flip:flip};
		} else {
			return {o:1,l:tmp.h,flip:flip};
		}
	}
	return false;
}
