/* 
 * EDOMI beta (Version 1.64) - Intelligente Steuerung und Visualisierung KNX-basierter Elektro-Installationen.
 * @link http://www.edomi.de 
 * @author Dr. Christian Gärtner <dr.christian.gaertner@googlemail.com> 
 * @copyright 2015,2016,2017 Dr. Christian Gärtner 
 * @license Freeware 
 *
 *     This file and all other files are part of EDOMI.
 *
 *     EDOMI is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 *     Diese und alle anderen Dateien sind Teil von EDOMI.
 *
 *     EDOMI wird in der Hoffnung, dass es nützlich sein wird, aber
 *     OHNE JEDE GEWÄHRLEISTUNG, bereitgestellt; sogar ohne die implizite
 *     Gewährleistung der MARKTFÄHIGKEIT oder EIGNUNG FÜR EINEN BESTIMMTEN ZWECK.
*/ 
//Controltyp 15 (Farbauswahl (Bild))
//----------------------------

function control15_constructControl(obj,item) {
	var n="<div id='e-"+item.id+"-container' style='position:absolute; left:0; top:0; width:100%; height:100%;'>";
		n+="<canvas id='e-"+item.id+"-canvas' style='position:absolute; left:0; top:0; width:100%; height:100%; box-sizing:border-box;'></canvas>";
		n+="<table cellpadding='0' cellspacing='0' border='0' style='position:absolute; left:0; top:0; width:100%; height:100%; pointer-events:none;'>";
			n+="<tr><td><span id='e-"+item.id+"-text'></span></td></tr>";
		n+="</table>";
		n+="<div id='e-"+item.id+"-cursor' style='display:none; position:absolute; z-index:99999; left:0; top:0; width:90px; height:90px; border-radius:100%; border-style:solid; border-width:5px; pointer-events:none;'></div>";
	n+="</div>";
	obj.innerHTML=n;

	document.getElementById("e-"+item.id+"-canvas").addEventListener(downEvent,function(){if (!checkClick()){return;} control15_Start(item.id);},false);	
}

function control15_refreshControl(obj,init) {
	var kovalue=getKoValue(obj);
	document.getElementById("e-"+obj.dataset.id+"-text").innerHTML=pS(obj.dataset.d_text,kovalue);
	control15_Init(obj.dataset.id,obj.dataset.d_img);
}

function control15_Init(elementId,img) {
	var d=document.getElementById("e-"+elementId);
	if (d) {
		var canvas=document.getElementById("e-"+elementId+"-canvas");
		var canvassize=element_getSize(canvas);
		var c=canvasScale(canvas,canvassize.w,canvassize.h);

		if (c!==false) {
			c.clearRect(0,0,canvassize.w,canvassize.h);
			if (img!="") {
				var tmp=new Image();
				tmp.src="../data/liveproject/visu/img/"+img;
				tmp.onload=function() {c.drawImage(tmp,0,0,canvassize.w,canvassize.h);}
			}
		}
	}
}

function control15_Start(elementId) {
	if (!event) var event=window.event;
	var d=document.getElementById("e-"+elementId);

	element_drag.id=elementId;
	resetKoValue_Interval("");

	if (d.dataset.var2==1) {
		document.getElementById("e-"+elementId+"-text").style.display="none";
		document.getElementById("e-"+elementId+"-cursor").style.display="block";
	}

	control15_Move();

	window.addEventListener(moveEvent,control15_Move,false);
	window.addEventListener(upEvent,control15_Send,false);

	if (visu_allowScrolling) {
		//Scrolling temporär verhindern
		window.addEventListener(moveEvent,disableScrolling,false);
	}
}

function control15_Move() {
	if (!event) var event=window.event;
	if (element_drag.id>0) {
		var d=document.getElementById("e-"+element_drag.id);
		if (d) {
			var canvas=document.getElementById("e-"+element_drag.id+"-canvas");

			var pos=element_getMousePosition(d,canvas);

			var x=parseInt(pos.x);
			var y=parseInt(pos.y);			
			if (x<0) {x=0;}
			if (y<0) {y=0;}
			if (x>pos.w-1) {x=pos.w-1;}
			if (y>pos.h-1) {y=pos.h-1;}

			if (canvas.getContext) {
				var value="";
				var c=canvas.getContext("2d");
				var color=c.getImageData(x*displayPixelRatio,y*displayPixelRatio,1,1).data;
				var cursor=document.getElementById("e-"+element_drag.id+"-cursor");
				var cursorColor="";

				var minAlpha=parseInt(d.dataset.var3);
				if (isNaN(minAlpha)) {minAlpha=0;}
				if (minAlpha<0) {minAlpha=0;}
				if (minAlpha>255) {minAlpha=255;}

				if (color[3]<minAlpha) {
					if (d.dataset.var2==1) {
						cursor.style.display="none";
					}
					
				} else {
					if (d.dataset.var1==0) {
						var bw=RGBtoGREYSCALE(color[0],color[1],color[2]);
						if (bw!==false) {
							value=bw;
							cursorColor="rgb("+bw+","+bw+","+bw+")";
						}
					} else if (d.dataset.var1==1) {
						var rgb=RGBtoRGBHEX(color[0],color[1],color[2]);
						if (rgb!==false) {
							value=rgb;
							cursorColor="#"+rgb;					
						}
					} else if (d.dataset.var1==2) {
						var hsv=RGBtoHSV(color[0],color[1],color[2]);
						if (hsv!==false) {
							value=HSVtoHSVHEX(hsv[0],hsv[1],hsv[2]);
						}
						var rgb=RGBtoRGBHEX(color[0],color[1],color[2]);
						if (rgb!==false) {
							cursorColor="#"+rgb;			
						}
					}							

					if (d.dataset.var2==1) {
						cursor.style.display="block";
						cursor.style.left=parseInt(x-(cursor.offsetWidth/2))+'px';
						cursor.style.top=parseInt(y-(cursor.offsetHeight/2))+'px';
						cursor.style.borderColor=cursorColor;
					}

					//KO setzen und Wert merken
					element_drag.koeditvalue=value;
					setKoValue_Interval(element_drag.id,true,d.dataset.var4);			
				}
				
			}
		}
	}
}

function control15_Send() {
	var d=document.getElementById("e-"+element_drag.id);
	if (d) {

		if (element_drag.koeditvalue!="") {
			setKoValue_Interval(element_drag.id,false);
		}

		document.getElementById("e-"+element_drag.id+"-text").style.display="inline";
		document.getElementById("e-"+element_drag.id+"-cursor").style.display="none";

		element_drag.id=0;
		window.removeEventListener(moveEvent,control15_Move,false);
		window.removeEventListener(upEvent,control15_Send,false);

		if (visu_allowScrolling) {
			//Scrolling wieder freigeben
			window.removeEventListener(moveEvent,disableScrolling,false);
		}

	}
}
