/* 
 * EDOMI beta (Version 1.64) - Intelligente Steuerung und Visualisierung KNX-basierter Elektro-Installationen.
 * @link http://www.edomi.de 
 * @author Dr. Christian Gärtner <dr.christian.gaertner@googlemail.com> 
 * @copyright 2015,2016,2017 Dr. Christian Gärtner 
 * @license Freeware 
 *
 *     This file and all other files are part of EDOMI.
 *
 *     EDOMI is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 *     Diese und alle anderen Dateien sind Teil von EDOMI.
 *
 *     EDOMI wird in der Hoffnung, dass es nützlich sein wird, aber
 *     OHNE JEDE GEWÄHRLEISTUNG, bereitgestellt; sogar ohne die implizite
 *     Gewährleistung der MARKTFÄHIGKEIT oder EIGNUNG FÜR EINEN BESTIMMTEN ZWECK.
*/ 
//Controltyp 17 (Analoguhr)
//----------------------------

function control17_constructControl(obj,item) {
	var n="<div id='e-"+item.id+"-container' style='position:absolute; left:0; top:0; width:100%; height:100%;'>";
		n+="<canvas id='e-"+item.id+"-canvas' style='position:absolute; box-sizing:border-box;'></canvas>";
		n+="<table cellpadding='0' cellspacing='0' border='0' style='position:absolute; left:0; top:0; width:100%; height:100%;'>";
			n+="<tr><td><span id='e-"+item.id+"-text'></span></td></tr>";
		n+="</table>";
	n+="</div>";
	obj.innerHTML=n;

	if (obj.dataset.var0==1) {obj.addEventListener(downEvent,function(){if (!checkClick()){return;} visuElementClick(item.id);},false);}
}

function control17_refreshControl(obj,init) {
	var kovalue=getKoValue(obj);
	document.getElementById("e-"+obj.dataset.id+"-text").innerHTML=pS(obj.dataset.d_text,kovalue);
	control17_Draw(obj.dataset.id);
}

function control17_Draw(elementId) {
	var d=document.getElementById("e-"+elementId);
	if (d) {
		var kovalue=getKoValue(d);
		var canvas=document.getElementById("e-"+elementId+"-canvas");
		var canvassize=element_centerRatio(document.getElementById("e-"+elementId+"-container"),document.getElementById("e-"+elementId+"-canvas"));
		var c=canvasScale(canvas,canvassize.w,canvassize.h);

		if (c!==false) {
			c.clearRect(0,0,canvassize.w,canvassize.h);

			var r=(canvassize.w/2);
			var mx=(canvassize.w/2);
			var my=(canvassize.h/2);
			
			//KO-Value parsen
			if (kovalue.toString().substr(2,1)==":") {
				//KO = Uhrzeit-String
				kovalue=parseInt(kovalue.substr(0,2)*60)+parseInt(kovalue.substr(3,2))+parseFloat(kovalue.substr(6,2)/60);
			}
			kovalue=kovalue%1440; //alle 24h wieder bei 0 beginnen

			var minute=(kovalue-(60*(kovalue/60).toFixed(0)))*(360/60);
			var hour=kovalue/60*(360/12);

			c.strokeStyle=d.style.color;
			c.fillStyle=d.style.color;

			if (d.dataset.var1>0) {
				//----------------------
				//Zeiger
				//----------------------
				drawScala();

				if (d.dataset.var2>0) {c.lineWidth=d.dataset.var2;} else {c.lineWidth=r/30;}
				c.globalAlpha=1;
				c.lineCap="round";
				if (d.dataset.var8>0) {var minuteLenP=d.dataset.var8;} else {var minuteLenP=r-(r/6);}
				if (d.dataset.var9>0) {var hourLenP=d.dataset.var9;} else {var hourLenP=r-(r/3);}
				drawPointer(minute,minuteLenP);
				drawPointer(hour,hourLenP);

				//Mittelpunkt
				if (d.dataset.var1==2 || d.dataset.var1==4) {
					c.beginPath();
						c.arc(mx,my,c.lineWidth,0,2*Math.PI,false);
					c.fill();
				}

				if (d.dataset.var1==3 || d.dataset.var1==4) {
					var second=((kovalue-parseInt(kovalue))*360);
					c.lineWidth/=2;
					drawPointer(second,minuteLenP);
				}
			}

		}
	}
	
	function drawScala() {
		if (d.dataset.var5>0) {var hourLen=d.dataset.var5;} else {var hourLen=r/6;}
		var minuteLen=hourLen/2;

		//24h-Anzeige
		if (d.dataset.var7>0) {
			c.lineWidth=minuteLen;
			c.lineCap="butt";
			c.globalAlpha=(d.dataset.var7/100);
			c.beginPath();
				c.arc(mx,my,r-(minuteLen/2),-90*Math.PI/180,(kovalue/(1440)*360-90)*Math.PI/180,false);
			c.stroke();
		}
		
		//Ziffernblatt
		if (d.dataset.var6>0) {
			if (d.dataset.var4>0) {c.lineWidth=d.dataset.var4;} else {c.lineWidth=r/30;}
			if (d.dataset.var6>0) {c.globalAlpha=(d.dataset.var6/100);} else {c.globalAlpha=1;}
			if (d.dataset.var3==1) {var step=6;} else {var step=30;}
			c.lineCap="butt";					
			for (var t=0;t<359;t+=step) { //step 30: nur Stunden
				var x=Math.sin(t*Math.PI/180);
				var y=Math.cos(t*Math.PI/180);
				c.beginPath();
					c.moveTo(x*r+mx,y*r+my);
					if (t%30==0) {
						c.lineTo(x*(r-hourLen)+mx,y*(r-hourLen)+my);
					} else {
						c.lineTo(x*(r-minuteLen)+mx,y*(r-minuteLen)+my);
					}
				c.stroke();
			}
		}
	}
		
	function drawPointer(a,len) {
		var x=Math.sin((-a-180)*Math.PI/180);
		var y=Math.cos((-a-180)*Math.PI/180);
		c.beginPath();
			c.moveTo(mx,my);
			c.lineTo(x*len+mx,y*len+my);
		c.stroke();
	}
}
