/* 
 * EDOMI beta (Version 1.64) - Intelligente Steuerung und Visualisierung KNX-basierter Elektro-Installationen.
 * @link http://www.edomi.de 
 * @author Dr. Christian Gärtner <dr.christian.gaertner@googlemail.com> 
 * @copyright 2015,2016,2017 Dr. Christian Gärtner 
 * @license Freeware 
 *
 *     This file and all other files are part of EDOMI.
 *
 *     EDOMI is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 *     Diese und alle anderen Dateien sind Teil von EDOMI.
 *
 *     EDOMI wird in der Hoffnung, dass es nützlich sein wird, aber
 *     OHNE JEDE GEWÄHRLEISTUNG, bereitgestellt; sogar ohne die implizite
 *     Gewährleistung der MARKTFÄHIGKEIT oder EIGNUNG FÜR EINEN BESTIMMTEN ZWECK.
*/ 
//Controltyp 32 (Terminschaltuhr)
//----------------------------

function control32_constructControl(obj,item) {

	var mheight=(obj.dataset.var10!='')?obj.dataset.var10:40;

	var n="<table cellpadding='0' cellspacing='0' border='0' style='position:absolute; left:0; top:0; width:100%; height:100%;'>";
		n+="<tr style='height:"+mheight+"px;'>";
			n+="<td width='20%' align='center' id='e-"+item.id+"-last'>&lt;</td>";
			n+="<td width='60%' align='center' id='e-"+item.id+"-info'><div id='e-"+item.id+"-infotext' style='max-height:"+mheight+"px; overflow:hidden;'>"+item.title+"</div></td>";
			n+="<td width='20%' align='center' id='e-"+item.id+"-next'>&gt;</td>";
		n+="</tr>";
		n+="<tr><td colspan='3' align='center' style='border-top:1px solid;"+((obj.dataset.var3>0)?"border-bottom:1px solid;":"")+"'><div style='position:relative; height:100%;'><div id='e-"+item.id+"-edit' style='position:absolute; top:0; left:0; right:0; bottom:0; overflow-x:hidden; overflow-y:auto;'></div></div></td></tr>";
	if (obj.dataset.var3>0) {
		n+="<tr style='height:"+mheight+"px;'><td colspan='3'>";
			n+="<table cellpadding='0' cellspacing='0' border='0' style='width:100%; height:100%;'>";
				n+="<tr align='center'>";
		if (obj.dataset.var3 & 1) {n+="<td id='e-"+item.id+"-off'><div id='e-"+item.id+"-status0' style='max-height:"+mheight+"px; overflow:hidden; display:inline-block; border:1px solid transparent; border-radius:3px; padding:1px;'>aus</div></td>";}
		if (obj.dataset.var3 & 2) {n+="<td id='e-"+item.id+"-add'><div style='max-height:"+mheight+"px; overflow:hidden; display:inline-block;'>+</div></td>";}
		if (obj.dataset.var3 & 1) {n+="<td id='e-"+item.id+"-on'><div id='e-"+item.id+"-status1' style='max-height:"+mheight+"px; overflow:hidden; display:inline-block; border:1px solid transparent; border-radius:3px; padding:1px;'>ein</div></td>";}
				n+="</tr>";
			n+="</table>";
		n+="</td></tr>";
	}
	n+="</table>";
	obj.innerHTML=n;
		
	obj.dataset.cursor=0;
	obj.dataset.editmode=0;
	control32_ShowInfo(item.id);

	document.getElementById("e-"+item.id+"-last").addEventListener(downEvent,function(){if (!checkClick()){return;} showShortClickItem(this); scrollUp("e-"+item.id+"-edit");},false);
	document.getElementById("e-"+item.id+"-info").addEventListener(downEvent,function(){if (!checkClick()){return;} showShortClickItem(this); control32_ShowInfo(item.id);},false);
	document.getElementById("e-"+item.id+"-next").addEventListener(downEvent,function(){if (!checkClick()){return;} showShortClickItem(this); scrollDown("e-"+item.id+"-edit");},false);
	if (obj.dataset.var3 & 1) {
		document.getElementById("e-"+item.id+"-off").addEventListener(downEvent,function(){if (!checkClick()){return;} showShortClickItem(this); setKoValue(item.gaid,0);},false);
		document.getElementById("e-"+item.id+"-on").addEventListener(downEvent,function(){if (!checkClick()){return;} showShortClickItem(this); setKoValue(item.gaid,1);},false);
	}
	if (obj.dataset.var3 & 2) {
		document.getElementById("e-"+item.id+"-edit").addEventListener(downEvent,function(){if (!checkClick()){return;} control32_ShowInfoEdit(item.id);},false);
		document.getElementById("e-"+item.id+"-add").addEventListener(downEvent,function(){if (!checkClick()){return;} showShortClickItem(this); control32_New(item.id);},false);
	}
}

function control32_refreshControl(obj,init) {
	var kovalue=getKoValue(obj);
	control32_Switch(obj.dataset.id,kovalue);
}

function control32_ShowInfo(elementId) {
	var d=document.getElementById("e-"+elementId);

	if (d) {
		if (d.dataset.var9>0) {
			d.dataset.refreshtimer=clear_timeout(d.dataset.refreshtimer);
			d.dataset.refreshtimer=set_timeout("control32_ShowInfo('"+elementId+"');",d.dataset.var9*60000,d.id,"document.getElementById('"+d.id+"').dataset.refreshtimer");
		}
		d.dataset.editmode=0;
		d.dataset.cursor="";
		var n=elementId+AJAX_SEPARATOR1+"0"+AJAX_SEPARATOR1+d.dataset.cursor+AJAX_SEPARATOR1+d.dataset.var1+AJAX_SEPARATOR1+d.dataset.var5+AJAX_SEPARATOR1+d.dataset.var6+AJAX_SEPARATOR1+d.dataset.var7+AJAX_SEPARATOR1+d.dataset.var8+AJAX_SEPARATOR1;
		ajax("tsuInfo",1032,visu_visuid,0,n,"");
	}
}

function control32_ShowInfoEdit(elementId,force) {
	var d=document.getElementById("e-"+elementId);
	if (d) {
		if (!force && d.dataset.editmode==1) {return;}
		if (d.dataset.var9>0) {d.dataset.refreshtimer=clear_timeout(d.dataset.refreshtimer);}
		d.dataset.editmode=1;
		d.dataset.cursor="";
		var n=elementId+AJAX_SEPARATOR1+"0"+AJAX_SEPARATOR1+d.dataset.cursor+AJAX_SEPARATOR1+d.dataset.var1+AJAX_SEPARATOR1;
		ajax("tsuInfoEdit",1032,visu_visuid,0,n,"");
	}
}

function control32_New(elementId) {
	var d=document.getElementById("e-"+elementId);
	if (d) {
		if (d.dataset.var9>0) {d.dataset.refreshtimer=clear_timeout(d.dataset.refreshtimer);}
		d.dataset.editmode=1;
		if (d.dataset.var3 & 2) {
			var n=elementId+AJAX_SEPARATOR1+"0"+AJAX_SEPARATOR1+d.dataset.cursor+AJAX_SEPARATOR1+d.dataset.var1+AJAX_SEPARATOR1;
			ajax("tsuEdit",1032,visu_visuid,0,n,"-1");
		}
	}
}

function control32_Edit(elementId,id) {
	var d=document.getElementById("e-"+elementId);
	if (d) {
		if (d.dataset.var9>0) {d.dataset.refreshtimer=clear_timeout(d.dataset.refreshtimer);}
		if (d.dataset.var3 & 2) {
			var n=elementId+AJAX_SEPARATOR1+"0"+AJAX_SEPARATOR1+d.dataset.cursor+AJAX_SEPARATOR1+d.dataset.var1+AJAX_SEPARATOR1;
			ajax("tsuEdit",1032,visu_visuid,0,n,id);
		}
	}
}

function control32_Switch(elementId,mode) {
	var s0=document.getElementById("e-"+elementId+"-status0");
	var s1=document.getElementById("e-"+elementId+"-status1");
	if (s0 && s1) {
		if (mode==1) {
			s0.style.border="1px solid transparent";
			s1.style.border="1px solid";
		} else {
			s0.style.border="1px solid";
			s1.style.border="1px solid transparent";
		}
	}
}

//PHP-Callbacks
//----------------------------

function control32_callbackList(elementId,content) {
	var d=document.getElementById("e-"+elementId);
	if (d) {
		document.getElementById("e-"+elementId+"-edit").innerHTML=content;
		scrollToTop("e-"+elementId+"-edit");
	}
}

function control32_callbackEdit(elementId,content,cursor,fd,makros,auxKo) {
	var d=document.getElementById("e-"+elementId);
	if (d) {
		d.dataset.cursor=cursor;
		document.getElementById("e-"+elementId+"-edit").innerHTML=content;
		document.getElementById("e-"+elementId+"-fd1").value=fd[1];

		document.getElementById("e-"+elementId+"-fd2").dataset.list=makros;
		document.getElementById("e-"+elementId+"-fd2").dataset.value=fd[2];
		selectboxInit(document.getElementById("e-"+elementId+"-fd2"));

		document.getElementById("e-"+elementId+"-fd3").value=fd[3];
		document.getElementById("e-"+elementId+"-fd4").value=fd[4];
		document.getElementById("e-"+elementId+"-fd5").value=fd[5];
		document.getElementById("e-"+elementId+"-fd6").value=fd[6];
		document.getElementById("e-"+elementId+"-fd7").value=fd[7];
		document.getElementById("e-"+elementId+"-fd8").dataset.value=fd[8];
		selectboxInit(document.getElementById("e-"+elementId+"-fd8"));

		if (document.getElementById("e-"+elementId+"-fd9")) {
			document.getElementById("e-"+elementId+"-fd9").dataset.list=auxKo;
			checkboxInit(document.getElementById("e-"+elementId+"-fd9"));
		}

		scrollToTop("e-"+elementId+"-edit");
	}
}
