<?
/* 
 * EDOMI beta (Version 1.64) - Intelligente Steuerung und Visualisierung KNX-basierter Elektro-Installationen.
 * @link http://www.edomi.de 
 * @author Dr. Christian Gärtner <dr.christian.gaertner@googlemail.com> 
 * @copyright 2015,2016,2017 Dr. Christian Gärtner 
 * @license Freeware 
 *
 *     This file and all other files are part of EDOMI.
 *
 *     EDOMI is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 *     Diese und alle anderen Dateien sind Teil von EDOMI.
 *
 *     EDOMI wird in der Hoffnung, dass es nützlich sein wird, aber
 *     OHNE JEDE GEWÄHRLEISTUNG, bereitgestellt; sogar ohne die implizite
 *     Gewährleistung der MARKTFÄHIGKEIT oder EIGNUNG FÜR EINEN BESTIMMTEN ZWECK.
*/ 
?><? function writeToLog($procId,$condition,$logMsg,$errMsg=null,$cssClass=null) { if (global_logSysEnabled>0 || global_logErrEnabled>0) { global $global_procNames; $ts=getTimestamp(); if (!$pid=getmypid()) {$pid='?';} if (isEmpty($logMsg)) {$logMsg='-';} if ($procId>=0) {$procName=$global_procNames[$procId];} else {$procName='?';} if (global_logSysEnabled==1 || global_logErrEnabled==1) { $SEP=global_logTextSeparator; if (isEmpty($SEP)) {$SEP=chr(9);} if ($condition===false) { $txtStatus=$errMsg; if (isEmpty($txtStatus)) {$txtStatus='ERROR';} } else { $txtStatus='Ok'; } $txt=$ts[0].$SEP.$ts[1].$SEP.$procName.$SEP.$pid.$SEP.$logMsg.$SEP.$txtStatus; } if (global_logSysEnabled==2 || global_logErrEnabled==2) { if ($condition===false) { $html='<tr class="sErr">'; $txtStatus=$errMsg; if (isEmpty($txtStatus)) {$txtStatus='ERROR';} } else { if (isEmpty($cssClass)) {$html='<tr>';} else {$html='<tr class="'.$cssClass.'">';} $txtStatus='Ok'; } $html.='<td>'.$ts[0].'</td>'; $html.='<td>'.$ts[1].'</td>'; $html.='<td>'.$procName.'</td>'; $html.='<td>'.$pid.'</td>'; $html.='<td>'.htmlspecialchars($logMsg).'</td>'; $html.='<td>'.htmlspecialchars($txtStatus).'</td>'; $html.='</tr>'; } if (global_logSysEnabled>0 && $procId>=0) { if (global_logSysEnabled==1) {writeToLogSave(0,'SYSLOG_'.date("Y-m"),$txt,1);} if (global_logSysEnabled==2) {writeToLogSave(0,'SYSLOG_'.date("Y-m"),$html,2);} } if (global_logErrEnabled>0 && $condition===false) { if (global_logErrEnabled==1) {writeToLogSave(0,'ERRLOG_'.date("Y-m"),$txt,1);} if (global_logErrEnabled==2) {writeToLogSave(0,'ERRLOG_'.date("Y-m"),$html,2);} $fh=fopen(MAIN_PATH.'/www/data/tmp/errorcount.txt','a'); fwrite($fh,'X'); fclose($fh); } } if ($procId==1) { echo "\33[2K".date('d.m.Y H:i:s',strtotime($ts[0])).' '.substr($logMsg,0,60)."\n"; } return $condition; } function writeToCustomLog($logName,$logLevel,$logMsg) { if (global_logCustomEnabled>0) { $ts=getTimestamp(); if (!$pid=getmypid()) {$pid='?';} $logName=substr(preg_replace("/[^a-zA-Z0-9\ \-\_äöüÄÖÜß]/",'',$logName),0,100); } if (global_logCustomEnabled==1) { if (!isEmpty($logName)) { $SEP=global_logTextSeparator; if (isEmpty($SEP)) {$SEP=chr(9);} $txt=$ts[0].$SEP.$ts[1].$SEP.$pid.$SEP.$logLevel.$SEP.$logMsg; writeToLogSave(1,'CUSTOMLOG_'.$logName,$txt,1); } } else if (global_logCustomEnabled==2) { if (!isEmpty($logName)) { $html='<tr><td>'.$ts[0].'</td><td>'.$ts[1].'</td><td>'.$pid.'</td><td>'.((!isEmpty($logLevel))?htmlspecialchars($logLevel):'&nbsp;').'</td><td>'.((!isEmpty($logMsg))?htmlspecialchars($logMsg):'&nbsp;').'</td></tr>'; writeToLogSave(1,'CUSTOMLOG_'.$logName,$html,2); } } } function writeToMonLog($mode,$gaMode,$gaTyp,$gaId,$pa,$ga,$gaName,$gaValue,$serviceConfirm=false) { if ($mode==1 && $gaTyp==1) { if ($gaId>=0 && ((global_knxUnknownGA & 2) || $gaId!=0)) { $ts=getTimestamp(); $tsid=getTimestampId(); if ($serviceConfirm) { $tmpPa='EDOMI'; } else { $tmpPa=$pa; } sql_call("UPDATE edomiLive.RAMlivemon SET ts='".$tsid."',datetime='".$ts[0]."',ms='".$ts[1]."',pa='".sql_encodeValue($tmpPa)."',gamode='".$gaMode."',gatyp='".$gaTyp."',gaid='".$gaId."',ga='".sql_encodeValue($ga)."',ganame='".sql_encodeValue(substr($gaName,0,200))."',gavalue='".sql_encodeValue(substr($gaValue,0,200))."' ORDER BY ts ASC LIMIT 1"); } } if (global_logMonEnabled>0 && ((global_knxUnknownGA & 2) || $gaId!=0)) { if ($sysGa=getGADataFromID(6,2)) { if ($sysGa['value']!=0) { $ts=getTimestamp(); $cssClass=null; $info='?'; $infoTyp=0; if ($mode==0) { if ($gaMode==1) {$info='INIT'; $cssClass='sI';} if ($gaMode==2) {$info='START'; $cssClass='sS';} if ($gaMode==3) {$info='ENDE'; $cssClass='sX';} } else if ($mode==1) { if ($gaTyp==1) { $infoTyp=1; if ($gaId==0) {$gaId=''; $gaName='unbekannte GA'; $cssClass='sErr';} if ($gaMode==0) {$info='KNX REQUEST';} if ($gaMode==1) {$info='KNX RESPONSE';} if ($gaMode==2) {$info='KNX WRITE';} if ($gaMode==-1) {$info='KNX WRITE'; $gaValue='ungültiger Wert: '.$gaValue; $cssClass='sErr';} } if ($gaTyp==2) { $infoTyp=2; if ($gaMode==2) {$info='INTERN';} if ($gaMode==-1) {$info='INTERN'; $gaValue='ungültiger Wert: '.$gaValue; $cssClass='sErr';} } } else if ($mode==2) { if ($gaMode==1) {$info='IP-TELEGRAMM';} if ($gaMode==2) {$info='IR-BEFEHL';} if ($gaMode==3) {$info='EMAIL';} if ($gaMode==4) {$info='TELEFON';} } if (isEmpty($ga)) {$ga='-';} if (isEmpty($gaValue)) {$gaValue='-';} if (isEmpty($gaName)) {$gaName='-';} if ($infoTyp==0 || ($infoTyp==1 && ($sysGa['value'] & 1)) || ($infoTyp==2 && ($sysGa['value'] & 2))) { if (global_logMonEnabled==1) { $SEP=global_logTextSeparator; if (isEmpty($SEP)) {$SEP=chr(9);} $txt=$ts[0].$SEP.$ts[1].$SEP.$info.$SEP; if ($serviceConfirm) { $txt.='EDOMI'.$SEP; } else { $txt.=$pa.$SEP; } $txt.=$ga.$SEP.$gaId.$SEP.$gaName.$SEP.$gaValue; writeToLogSave(2,'MONLOG_'.date("Y-m-d"),$txt,1); return true; } else if (global_logMonEnabled==2) { if (isEmpty($pa)) {$pa='&nbsp;';} if (isEmpty($gaId)) {$gaId='&nbsp;';} if (isEmpty($cssClass)) {$html='<tr>';} else {$html='<tr class="'.$cssClass.'">';} $html.='<td>'.$ts[0].'</td>'; $html.='<td>'.$ts[1].'</td>'; $html.='<td>'.htmlspecialchars($info).'</td>'; if ($serviceConfirm) { $html.='<td>EDOMI</td>'; } else { $html.='<td>'.$pa.'</td>'; } $html.='<td>'.htmlspecialchars($ga).'</td>'; $html.='<td>'.$gaId.'</td>'; $html.='<td>'.htmlspecialchars($gaName).'</td>'; $html.='<td>'.htmlspecialchars($gaValue).'</td>'; $html.='</tr>'; writeToLogSave(2,'MONLOG_'.date("Y-m-d"),$html,2); return true; } } } } } return false; } function writeToLogSave($logTyp,$logName,$entry,$format) { $fileName=''; $header=''; $entry=str_replace("\n",'[LF]',$entry); $entry=str_replace("\r",'[CR]',$entry); if ($format==1) { $fileName=MAIN_PATH.'/www/data/log/'.$logName.'.log'; if (!file_exists($fileName)) { $ts=getTimestamp(); if (!$pid=getmypid()) {$pid='?';} $header='{EDOMI,'.$logName.'.log,'.date('d.m.Y',strtotime($ts[0])).','.date('H:i:s',strtotime($ts[0])).','.$ts[1].','.$pid.'}'; if ($logTyp==0) { $header.='{Zeitstempel,ms,Prozess,PID,Meldung,Status}'; } else if ($logTyp==1) { $header.='{Zeitstempel,ms,PID,LogLevel,Meldung}'; } else if ($logTyp==2) { $header.='{Zeitstempel,ms,Typ,PA,GA/KO,KO-ID,Name,Wert}'; } } } else if ($format==2) { $fileName=MAIN_PATH.'/www/data/log/'.$logName.'.htm'; if (!file_exists($fileName)) { $ts=getTimestamp(); if (!$pid=getmypid()) {$pid='?';} if ($logTyp==0) { $meta='{EDOMI,'.$logName.'.htm,'.date('d.m.Y',strtotime($ts[0])).','.date('H:i:s',strtotime($ts[0])).','.$ts[1].','.$pid.'}'; $header='<html><head><style>body {background:#ffffff;} .log {background:#ffffff; font-family:EDOMIfontMono,Menlo,Courier,monospace; line-height:12px; font-size:10px; color:#393930; margin:0; padding:0;} .log td {padding:1px 5px 1px 5px; border-right:1px solid #a9a9a0;} '; $header.='.sErr {color:#ff0000;}'; $header.='.sL {background:#c0c0ff;}'; $header.='.sP {background:#e0e000;}'; $header.='.sI {background:-webkit-repeating-linear-gradient(top,#e0e000,#e0e000 2px,#80e000 2px,#80e000 4px);}'; $header.='.sS {background:#80e000;}'; $header.='.sE {background:#ff8080;}'; $header.='.sX {background:#b0b0b0;}'; $header.='</style></head><body>'; $header.='<table class="log" border="0" cellspacing="0" cellpadding="0" style="border-left:1px solid #a9a9a0; border-bottom:1px solid #a9a9a0; white-space:nowrap;">'; $header.='<tr><td colspan="6" style="color:#ffffff; background:#393930; padding:5px;">'.$meta.'</td></tr>'; $header.='<tr style="background:#c9c9c0;"><td>Zeitstempel</td><td>ms</td><td>Prozess</td><td>PID</td><td>Meldung</td><td>Status</td></tr>'; } else if ($logTyp==1) { $meta='{EDOMI,'.$logName.'.htm,'.date('d.m.Y',strtotime($ts[0])).','.date('H:i:s',strtotime($ts[0])).','.$ts[1].','.$pid.'}'; $header='<html><head><style>body {background:#ffffff;} .log {background:#ffffff; font-family:EDOMIfontMono,Menlo,Courier,monospace; line-height:12px; font-size:10px; color:#393930; margin:0; padding:0;} .log td {padding:1px 5px 1px 5px; border-right:1px solid #a9a9a0;}'; $header.='</style></head><body>'; $header.='<table class="log" border="0" cellspacing="0" cellpadding="0" style="border-left:1px solid #a9a9a0; border-bottom:1px solid #a9a9a0; white-space:nowrap;">'; $header.='<tr><td colspan="5" style="color:#ffffff; background:#393930; padding:5px;">'.$meta.'</td></tr>'; $header.='<tr style="background:#c9c9c0;"><td>Zeitstempel</td><td>ms</td><td>PID</td><td>LogLevel</td><td>Meldung</td></tr>'; } else if ($logTyp==2) { $meta='{EDOMI,'.$logName.'.htm,'.date('d.m.Y',strtotime($ts[0])).','.date('H:i:s',strtotime($ts[0])).','.$ts[1].','.$pid.'}'; $header='<html><head><style>body {background:#ffffff;} .log {background:#ffffff; font-family:EDOMIfontMono,Menlo,Courier,monospace; line-height:12px; font-size:10px; color:#393930; margin:0; padding:0;} .log td {padding:1px 5px 1px 5px; border-right:1px solid #a9a9a0;}'; $header.='.sErr {color:#ffffff; background:#ff0000;}'; $header.='.sI {background:-webkit-repeating-linear-gradient(top,#e0e000,#e0e000 2px,#80e000 2px,#80e000 4px);}'; $header.='.sS {background:#80e000;}'; $header.='.sX {background:#b0b0b0;}'; $header.='</style></head><body>'; $header.='<table class="log" border="0" cellspacing="0" cellpadding="0" style="border-left:1px solid #a9a9a0; border-bottom:1px solid #a9a9a0; white-space:nowrap;">'; $header.='<tr><td colspan="8" style="color:#ffffff; background:#393930; padding:5px;">'.$meta.'</td></tr>'; $header.='<tr style="background:#c9c9c0;"><td>Zeitstempel</td><td>ms</td><td>Typ</td><td>PA</td><td>GA/KO</td><td>KO-ID</td><td>Name</td><td>Wert</td></tr>'; } } } if (!isEmpty($fileName)) { $fh=fopen($fileName,'a'); if (!isEmpty($header)) {fwrite($fh,$header."\n");} fwrite($fh,$entry."\n"); fclose($fh); } } ?>
